(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["DateTimeNet"] = factory();
	else
		root["DateTimeNet"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(1);


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;
exports.DateTimeMode = exports.DateTimeKind = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _en = __webpack_require__(2);

var _en2 = _interopRequireDefault(_en);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DateTimeKind = exports.DateTimeKind = {
  unspecified: 0,
  utc: 1,
  local: 2
};

var DateTimeMode = exports.DateTimeMode = {
  dateTime: 0,
  date: 1,
  time: 2
};

var DateTime = function () {
  function DateTime(yearOrTicksOrDate, month, day, hour, minute, sec, msec) {
    _classCallCheck(this, DateTime);

    var ticksOrDate = void 0;
    this.kind = DateTimeKind.unspecified;

    if (typeof yearOrTicksOrDate === "undefined") {
      ticksOrDate = new Date().getTime() + DateTime.getTimezoneOffsetTicks();
      this.kind = DateTimeKind.local;
    } else if (typeof month === "undefined") {
      ticksOrDate = yearOrTicksOrDate;

      if (typeof ticksOrDate === "string") {
        var ticks = DateTime.msDateRe.exec(ticksOrDate);

        if (ticks !== null) {
          ticksOrDate = +ticks[1];
          this.kind = DateTimeKind.utc;
        } else if (DateTime.isoDateRe.test(ticksOrDate)) this.kind = DateTimeKind.utc;
      } else if (ticksOrDate instanceof DateTime) this.kind = yearOrTicksOrDate.kind;
    } else {
      ticksOrDate = Date.UTC(yearOrTicksOrDate, month - 1, day || 1, hour || 0, minute || 0, sec || 0, msec || 0);
      this.kind = DateTimeKind.local;
    }

    this.value = new Date(ticksOrDate instanceof DateTime ? ticksOrDate.getTicks() : ticksOrDate);
  }

  _createClass(DateTime, [{
    key: "getYears",
    value: function getYears() {
      return this.value.getUTCFullYear();
    }
  }, {
    key: "getMonths",
    value: function getMonths() {
      return this.value.getUTCMonth() + 1;
    }
  }, {
    key: "getTotalMonths",
    value: function getTotalMonths() {
      return Math.abs(this.getYears()) * 12 + this.getMonths();
    }
  }, {
    key: "getDays",
    value: function getDays() {
      return this.value.getUTCDate();
    }
  }, {
    key: "getDayOfWeek",
    value: function getDayOfWeek() {
      return this.value.getUTCDay();
    }
  }, {
    key: "getHours",
    value: function getHours() {
      return this.value.getUTCHours();
    }
  }, {
    key: "getMinutes",
    value: function getMinutes() {
      return this.value.getUTCMinutes();
    }
  }, {
    key: "getSeconds",
    value: function getSeconds() {
      return this.value.getUTCSeconds();
    }
  }, {
    key: "getMilliseconds",
    value: function getMilliseconds() {
      return this.value.getUTCMilliseconds();
    }
  }, {
    key: "getTicks",
    value: function getTicks() {
      return this.value.getTime();
    }
  }, {
    key: "getKind",
    value: function getKind() {
      return this.kind;
    }
  }, {
    key: "setYears",
    value: function setYears(value) {
      this.value.setUTCFullYear(value);return this;
    }
  }, {
    key: "setMonths",
    value: function setMonths(value) {
      this.value.setUTCMonth(value - 1);return this;
    }
  }, {
    key: "setDays",
    value: function setDays(value) {
      this.value.setUTCDate(value);return this;
    }
  }, {
    key: "setHours",
    value: function setHours(value) {
      this.value.setUTCHours(value);return this;
    }
  }, {
    key: "setMinutes",
    value: function setMinutes(value) {
      this.value.setUTCMinutes(value);return this;
    }
  }, {
    key: "setSeconds",
    value: function setSeconds(value) {
      this.value.setUTCSeconds(value);return this;
    }
  }, {
    key: "setMilliseconds",
    value: function setMilliseconds(value) {
      this.value.setUTCMilliseconds(value);return this;
    }
  }, {
    key: "setTicks",
    value: function setTicks(value) {
      this.value = new Date(value);return this;
    }
  }, {
    key: "setKind",
    value: function setKind(value) {
      this.kind = value;return this;
    }
  }, {
    key: "incYears",
    value: function incYears() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return this.setYears(this.getYears() + value);
    }
  }, {
    key: "incMonths",
    value: function incMonths() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return this.setMonths(this.getMonths() + value);
    }
  }, {
    key: "incDays",
    value: function incDays() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return this.setDays(this.getDays() + value);
    }
  }, {
    key: "incHours",
    value: function incHours() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return this.setHours(this.getHours() + value);
    }
  }, {
    key: "incMinutes",
    value: function incMinutes() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return this.setMinutes(this.getMinutes() + value);
    }
  }, {
    key: "incSeconds",
    value: function incSeconds() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return this.setSeconds(this.getSeconds() + value);
    }
  }, {
    key: "incMilliseconds",
    value: function incMilliseconds() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return this.setMilliseconds(this.getMilliseconds() + value);
    }
  }, {
    key: "incTicks",
    value: function incTicks() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return this.setTicks(this.getTicks() + value);
    }
  }, {
    key: "addYears",
    value: function addYears() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return new DateTime(this).incYears(value);
    }
  }, {
    key: "addMonths",
    value: function addMonths() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return new DateTime(this).incMonths(value);
    }
  }, {
    key: "addDays",
    value: function addDays() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return new DateTime(this).incDays(value);
    }
  }, {
    key: "addHours",
    value: function addHours() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return new DateTime(this).incHours(value);
    }
  }, {
    key: "addMinutes",
    value: function addMinutes() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return new DateTime(this).incMinutes(value);
    }
  }, {
    key: "addSeconds",
    value: function addSeconds() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return new DateTime(this).incSeconds(value);
    }
  }, {
    key: "addMilliseconds",
    value: function addMilliseconds() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return new DateTime(this).incMilliseconds(value);
    }
  }, {
    key: "addTicks",
    value: function addTicks() {
      var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
      return new DateTime(this).incTicks(value);
    }
  }, {
    key: "floor",
    value: function floor(to) {
      return this.setTicks(DateTime._floorTicks(this, to));
    }
  }, {
    key: "toLocalTime",
    value: function toLocalTime() {
      return this._convertTime(true);
    }
  }, {
    key: "toUniversalTime",
    value: function toUniversalTime() {
      return this._convertTime(false);
    }
  }, {
    key: "getDate",
    value: function getDate() {
      return new DateTime(this).floor("day").setKind(DateTimeKind.unspecified);
    }
  }, {
    key: "setDate",
    value: function setDate(value, month, day) {
      if (value instanceof Date || value instanceof DateTime || typeof month === "undefined") {
        var temp = DateTime.cast(value);
        value = temp.getYears();
        month = temp.getMonths();
        day = temp.getDays();
      }

      return this.setYears(value).setMonths(month).setDays(day || 1);
    }
  }, {
    key: "getTime",
    value: function getTime() {
      return new DateTime(1970, 1, 1, this.getHours(), this.getMinutes(), this.getSeconds(), this.getMilliseconds()).setKind(DateTimeKind.unspecified);
    }
  }, {
    key: "setTime",
    value: function setTime(value, min, sec, msec) {
      if (value instanceof Date || value instanceof DateTime || typeof min === "undefined") {
        var temp = DateTime.cast(value);
        value = temp.getHours();
        min = temp.getMinutes();
        sec = temp.getSeconds();
        msec = temp.getMilliseconds();
      }

      return this.setHours(value).setMinutes(min).setSeconds(sec || 0).setMilliseconds(msec || 0);
    }
  }, {
    key: "valueOf",
    value: function valueOf() {
      return this.getTicks();
    }
  }, {
    key: "toString",
    value: function toString() {
      return this.format("yyyy-MM-dd HH:mm:ss.l") + (this.getKind() === DateTimeKind.local ? " (local)" : "") + (this.getKind() === DateTimeKind.utc ? " (utc)" : "");
    }
  }, {
    key: "compareTo",
    value: function compareTo(value, floorTo) {
      var dateTime1 = this;
      var dateTime2 = DateTime.cast(value);

      if (dateTime1.getKind() !== dateTime2.getKind() && dateTime1.getKind() !== DateTimeKind.unspecified && dateTime2.getKind() !== DateTimeKind.unspecified) {
        dateTime2 = dateTime1.getKind() === DateTimeKind.utc ? dateTime2.toUniversalTime() : dateTime2.toLocalTime();
      }

      return DateTime._floorTicks(dateTime1, floorTo) - DateTime._floorTicks(dateTime2, floorTo);
    }
  }, {
    key: "humanize",
    value: function humanize(options) {
      var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _en2.default;
      var humanizeFormats = arguments[2];

      options = Object.assign({
        useDate: true,
        useTime: true,
        alwaysWithTime: true,
        singleLine: true,
        separator: "|"
      }, options);

      if (!options.useDate && !options.useTime) throw "DateTime.toSimpleText: one of the 'options.useDate' or 'options.useTime' must be true";

      var fmts = humanizeFormats == null ? locale.humanizeFormats.short : humanizeFormats;
      var dateTimeNow = DateTime.cast(options.dateTimeNow);
      var dateStr = "";
      var timeStr = "";

      if (options.useDate) {
        var temp = new DateTime(dateTimeNow);
        var crLeft = this.compareTo(temp.incDays(-7), "day");
        var crRight = this.compareTo(temp.incDays(14), "day");

        if (crLeft >= 0 && crRight <= 0) {
          var res = [];
          res[0] = fmts.dateWeekAgo;
          res[6] = fmts.dateYesterday;
          res[7] = fmts.dateToday;
          res[8] = fmts.dateTomorrow;
          res[14] = fmts.dateInWeek;

          for (var i = -7; i <= 7; i++) {
            if (this.compareTo(dateTimeNow.addDays(i), "day") === 0) {
              dateStr = res[i + 7] || (i < 0 ? fmts.dateDaysAgo.replace("{0}", String(-i)) : fmts.dateInDays.replace("{0}", String(i)));
              break;
            }
          }
        } else {
          if (this.getYears() === dateTimeNow.getYears()) dateStr = this.format(locale.abbreviatedMonthDayPattern);else if (this.getYears() > locale.twoDigitYearMax - 100 && this.getYears() <= locale.twoDigitYearMax) dateStr = this.format(locale.abbreviatedShortDatePattern);else dateStr = this.format(locale.abbreviatedDatePattern);
        }
      }

      if (options.useTime) {
        if (this.compareTo(dateTimeNow, "day") === 0) dateStr = "";

        var periodMsecs = ((23 * 60 + 29) * 60 + 59) * 1000 + 999; // number of milliseconds in 23:29:59.999
        var _temp = new DateTime(dateTimeNow);
        var _crLeft = this.compareTo(_temp.incMilliseconds(-periodMsecs));
        var _crRight = this.compareTo(_temp.incMilliseconds(periodMsecs * 2));

        if (_crLeft >= 0 && _crRight <= 0) {
          dateStr = "";
          var diffMsecs = this.getTicks() - dateTimeNow.getTicks();

          if (Math.abs(diffMsecs) < 59 * 1000 + 500) {
            var val = +(diffMsecs / 1000).toFixed();
            timeStr = Math.abs(val) <= 1 ? val <= 0 ? fmts.timeSecondAgo : fmts.timeInSecond : val < 0 ? fmts.timeSecondsAgo.replace("{0}", String(Math.abs(val))) : fmts.timeInSeconds.replace("{0}", String(val));
          } else if (Math.abs(diffMsecs) < (59 * 60 + 29) * 1000 + 500) {
            var _val = +(diffMsecs / (60 * 1000)).toFixed();
            timeStr = Math.abs(_val) <= 1 ? _val <= 0 ? fmts.timeMinuteAgo : fmts.timeInMinute : _val < 0 ? fmts.timeMinutesAgo.replace("{0}", String(Math.abs(_val))) : fmts.timeInMinutes.replace("{0}", String(_val));
          } else {
            var _val2 = +(diffMsecs / (60 * 60 * 1000)).toFixed();
            timeStr = Math.abs(_val2) <= 1 ? _val2 <= 0 ? fmts.timeHourAgo : fmts.timeInHour : _val2 < 0 ? fmts.timeHoursAgo.replace("{0}", String(Math.abs(_val2))) : fmts.timeInHours.replace("{0}", String(_val2));
          }
        } else if (options.alwaysWithTime) timeStr = this.format(locale.shortTimePattern);
      }

      return options.singleLine ? dateStr && timeStr ? fmts.dateTimeCombined.replace("{0}", dateStr.replace(options.separator, " ")).replace("{1}", timeStr.replace(options.separator, " ")) : dateStr.replace(options.separator, " ") + timeStr.replace(options.separator, " ") : dateStr && timeStr ? [dateStr.replace(options.separator, " "), timeStr.replace(options.separator, " ")] : dateStr ? dateStr.split(options.separator) : timeStr.split(options.separator);
    }
  }, {
    key: "toDisplayString",
    value: function toDisplayString(options) {
      var localeConfig = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _en2.default.config;

      options = Object.assign({}, options);
      options.dateTimeNow = DateTime.now().setYears(localeConfig.twoDigitYearMax - 100 - 1);
      return this.humanize(options, localeConfig);
    }

    // http://blog.stevenlevithan.com/archives/date-time-format/comment-page-3

  }, {
    key: "format",
    value: function format(mask) {
      var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _en2.default;

      var token = /d{1,4}|M{1,4}|y{1,4}|([Hhms])\1?|tt|[Ll]|"[^"]*"|'[^']*'/g;
      var pad = function pad(val) {
        var len = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;
        return String(val).padStart(len, "0");
      };

      var d = this.getDays(),
          D = this.getDayOfWeek(),
          M = this.getMonths(),
          y = this.getYears(),
          H = this.getHours(),
          m = this.getMinutes(),
          s = this.getSeconds(),
          L = this.getMilliseconds(),
          flags = {
        d: d,
        dd: pad(d),
        ddd: locale.abbreviatedDayNames[D],
        dddd: locale.dayNames[D],
        M: M,
        MM: pad(M),
        MMM: locale.abbreviatedMonthNames[M - 1],
        MMMM: locale.monthNames[M - 1],
        y: Number(String(y).slice(2)),
        yy: String(y).slice(2),
        yyy: pad(y, 3),
        yyyy: pad(y, 4),
        h: H % 12 || 12,
        hh: pad(H % 12 || 12),
        H: H,
        HH: pad(H),
        m: m,
        mm: pad(m),
        s: s,
        ss: pad(s),
        l: pad(L, 3),
        L: pad(L > 99 ? Math.round(L / 10) : L),
        tt: H < 12 ? "AM" : "PM"
      };

      return mask.replace(token, function ($0) {
        return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
      });
    }
  }, {
    key: "_convertTime",
    value: function _convertTime(toLocal) {
      var result = new DateTime(this);

      if (toLocal && result.getKind() !== DateTimeKind.local || !toLocal && result.getKind() !== DateTimeKind.utc) {
        return result.incMilliseconds(DateTime.getTimezoneOffsetTicks() * (toLocal ? 1 : -1)).setKind(toLocal ? DateTimeKind.local : DateTimeKind.utc);
      }

      return result;
    }
  }], [{
    key: "getTimezoneOffsetTicks",
    value: function getTimezoneOffsetTicks() {
      var now = new Date();

      var nowUtc = new Date(now.getUTCFullYear(), now.getUTCMonth(), now.getUTCDate(), now.getUTCHours(), now.getUTCMinutes(), now.getUTCSeconds(), now.getUTCMilliseconds());

      return now.getTime() - nowUtc.getTime();
    }
  }, {
    key: "cast",
    value: function cast(value) {
      return value instanceof DateTime ? value : new DateTime(value);
    }
  }, {
    key: "utcNow",
    value: function utcNow() {
      return new DateTime().toUniversalTime();
    }
  }, {
    key: "now",
    value: function now() {
      return new DateTime();
    }
  }, {
    key: "getTimezoneOffset",
    value: function getTimezoneOffset() {
      return +(DateTime.getTimezoneOffsetTicks() / 60 / 60 / 1000).toFixed(1);
    }
  }, {
    key: "is24HoursPattern",
    value: function is24HoursPattern(pattern) {
      var hourFormat = new RegExp("h+", "i").exec(pattern);
      var ch = hourFormat ? hourFormat[0] : null;

      return !hourFormat || ch.toLocaleLowerCase() !== ch.toLocaleUpperCase() && ch.toLocaleUpperCase() === ch;
    }
  }, {
    key: "parseDate",
    value: function parseDate(s) {
      var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _en2.default;

      var re = /^(\d{1,4})(([.\-/ ] ?(\d{1,2})([.\-/ ] ?(\d{1,4}))?(?:$| +.*$))|$)/i;
      var matches = re.exec(s.trim());

      if (matches) {
        var parts = [matches[1]];

        if (matches[4] != null) parts[1] = matches[4];

        if (matches[6] != null) parts[2] = matches[6];

        var curDate = DateTime.now();
        var co = locale.dateCompsOrder;
        var year = parts.length === 3 ? +parts[co.indexOf("y")] : curDate.getYears();
        var month = parts.length >= 2 ? +parts[(parts.length === 2 ? co.replace("y", "") : co).indexOf("m")] : curDate.getMonths();
        var day = parts.length === 1 ? +parts[0] : +parts[(parts.length === 2 ? co.replace("y", "") : co).indexOf("d")];

        if (year >= 1 && year <= 9999 && month >= 1 && month <= 12 && day >= 1 && day <= 31) {
          if (year < 100) {
            var major = Math.round(locale.twoDigitYearMax / 100) * 100;
            var minor = locale.twoDigitYearMax - major;

            year = year <= minor ? major + year : major + year - 100;
          }

          var date = new DateTime(year, month, day);

          if (!isNaN(date.getTicks()) && date.getYears() === year && date.getMonths() === month && date.getDays() === day && date.getTicks() >= DateTime.cast(locale.minSupportedDate).getTicks() && date.getTicks() <= DateTime.cast(locale.maxSupportedDate).getTicks()) {
            return date;
          }
        }
      }

      return null;
    }
  }, {
    key: "parseTime",
    value: function parseTime(s) {
      var re = /^(0?\d|1\d|2[0-3]|am?|pm?)(([.: ](0?\d|[1-5]\d|am?|pm?)([.: ](0?\d|[1-5]\d|am?|pm?))?(?:$| +.*$))|$)/i;
      var matches = re.exec(s.trim());

      if (matches) {
        var parts = [matches[1]];

        if (matches[4] != null) parts[1] = matches[4];

        if (matches[6] != null) parts[2] = matches[6];

        var periodCount = 0;
        var numbers = [];
        var am = true;

        for (var i = 0, j = 0; i < parts.length; i++) {
          var n = parseInt(parts[i], 10);

          if (isNaN(n)) {
            am = parts[i][0].toLowerCase() === "a";
            n = am ? -1 : -2;
            periodCount++;
          } else numbers[j++] = n;

          if (periodCount > 1 || parts.length === 3 && i === 1 && n < 0) return null;
        }

        if (!numbers.length) return null;

        var hours = numbers[0];
        var mins = numbers.length > 1 ? numbers[1] : 0;

        if (hours > 12 && periodCount && am) return null;

        if (hours === 12 && periodCount && am) hours = 0;

        if (hours < 12 && !am) hours += 12;

        return new DateTime(0).setTime(hours, mins);
      }

      return null;
    }
  }, {
    key: "parseDateTime",
    value: function parseDateTime(s) {
      var locale = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _en2.default;

      var parts = s.trim().split(/\s+/);
      var timeStartIndex = -1;
      var periodIndex = -1;

      for (var i = parts.length - 1; i >= 0; i--) {
        if (timeStartIndex < 0 && parts[i].indexOf(":") >= 0) timeStartIndex = i;

        if (periodIndex < 0 && parts[i].toLowerCase().match(/^am?|pm?$/)) periodIndex = i;
      }

      if (periodIndex >= 0 && timeStartIndex >= 0 && periodIndex < timeStartIndex) timeStartIndex = periodIndex;else if (periodIndex >= 0 && timeStartIndex < 0) timeStartIndex = periodIndex + (periodIndex === parts.length - 1 ? -1 : 0);else if (timeStartIndex < 0) timeStartIndex = parts.length - (parts.length >= 5 ? 2 : parts.length > 1 ? 1 : 0);

      var dateParts = parts.slice(0, timeStartIndex);
      var timeParts = parts.slice(timeStartIndex);

      if (!dateParts.length && !timeParts.length) return null;

      var date = dateParts.length ? DateTime.parseDate(dateParts.join(" "), locale) : DateTime.now().setTime(0);

      if (!date) return null;

      if (timeParts.length) {
        var time = DateTime.parseTime(timeParts.join(" "));
        if (!time) return null;
        date.setTime(time);
      }

      return date.setKind(DateTimeKind.unspecified);
    }
  }, {
    key: "getShortenedRangeText",
    value: function getShortenedRangeText(from, to, mode) {
      var locale = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _en2.default;

      var valueFrom = from ? DateTime.cast(from) : null;
      var valueTo = to ? DateTime.cast(to) : null;

      if (mode === DateTimeMode.dateTime) {
        if (valueFrom) valueFrom = valueFrom.toLocalTime();

        if (valueTo) valueTo = valueTo.toLocalTime();
      }

      var now = DateTime.now();

      var fromFormat = mode === DateTimeMode.time ? locale.rangeFormats.timeFromFormat : locale.rangeFormats.dateTimeFromFormat;
      var toFormat = mode === DateTimeMode.time ? locale.rangeFormats.timeToFormat : locale.rangeFormats.dateTimeToFormat;
      var rangeFormat = mode === DateTimeMode.time ? locale.rangeFormats.timeRangeFormat : locale.rangeFormats.dateTimeRangeFormat;

      var formatDate = function formatDate(date) {
        var year = date.getYears();

        if (now.getYears() === year) return date.format(locale.shortMonthDayPattern);

        if (year > locale.twoDigitYearMax - 100 && year <= locale.twoDigitYearMax) return date.format(locale.shortestDatePattern);

        return date.format(locale.shortDatePattern);
      };

      var formatTime = function formatTime(time) {
        return time.format(locale.shortTimePattern);
      };

      var formatValue = function formatValue(dateTime) {
        var subMode = mode;

        if (mode === DateTimeMode.dateTime) if (valueFrom && valueTo && dateTime === valueTo && valueFrom.compareTo(valueTo) !== 0 && valueFrom.compareTo(valueTo, "day") === 0) {
          subMode = DateTimeMode.time;
        } else if (dateTime.getTime().getTicks() === 0 && (!valueFrom || !valueTo || valueTo.compareTo(valueFrom.addDays()) >= 0)) {
          subMode = DateTimeMode.date;

          if (dateTime === valueTo) dateTime = valueTo.addDays(-1);
        }

        switch (subMode) {
          case DateTimeMode.dateTime:
            return formatDate(dateTime) + " " + formatTime(dateTime);
          case DateTimeMode.date:
            return formatDate(dateTime);
          case DateTimeMode.time:
            return formatTime(dateTime);
          default:
            throw "DateTime.getShortenedRangeText: invalid mode";
        }
      };

      var valueFromFormatted = valueFrom ? formatValue(valueFrom) : "";
      var valueToFormatted = valueTo ? formatValue(valueTo) : "";

      var text = valueFrom && valueTo ? valueFromFormatted === valueToFormatted ? valueFromFormatted : rangeFormat.replace("{0}", valueFromFormatted).replace("{1}", valueToFormatted) : valueFrom ? fromFormat.replace("{0}", valueFromFormatted) : toFormat.replace("{0}", valueToFormatted);

      text = text.replace("{1}", "").replace("{2}", "").trim();

      return text;
    }
  }, {
    key: "_floorTicks",
    value: function _floorTicks(dateTime) {
      var floorTo = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "none";

      var toYear = floorTo === "year";
      var toMonth = floorTo === "month";
      var toDay = floorTo === "day";
      var toHour = floorTo === "hour";
      var toMinute = floorTo === "minute";
      var toSecond = floorTo === "second";
      var noFloor = floorTo === "none";

      if (!toYear && !toMonth && !toDay && !toHour && !toMinute && !toSecond && !noFloor) throw "DateTime.compareTo: invalid 'floorTo' format";

      return noFloor ? dateTime.getTicks() : Date.UTC(dateTime.getYears(), toYear ? 0 : dateTime.getMonths() - 1, toYear || toMonth ? 1 : dateTime.getDays(), toYear || toMonth || toDay ? 0 : dateTime.getHours(), toYear || toMonth || toDay || toHour ? 0 : dateTime.getMinutes(), toYear || toMonth || toDay || toHour || toMinute ? 0 : dateTime.getSeconds(), toYear || toMonth || toDay || toHour || toMinute || toSecond ? 0 : dateTime.getMilliseconds());
    }
  }]);

  return DateTime;
}();

DateTime.msDateRe = /\/Date\((-?\d+)\)\//;
DateTime.isoDateRe = /^(\d{4})(?:-?W(\d+)(?:-?(\d+)D?)?|(?:-(\d+))?-(\d+))(?:[T ](\d+):(\d+)(?::(\d+)(?:\.(\d+))?)?)?(?:Z(-?\d*))?$/;
exports.default = DateTime;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;
exports.default = {
  dateCompsOrder: "mdy",
  minSupportedDate: "0000-01-01T00:00:00.000Z",
  maxSupportedDate: "9999-12-31T23:59:59.999Z",
  abbreviatedDayNames: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
  monthNames: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
  abbreviatedMonthNames: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
  dayNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
  shortDateTimePattern: "M/d/yyyy h:mm tt",
  abbreviatedDatePattern: "d MMM yyyy",
  abbreviatedShortDatePattern: "d MMM yyyy",
  shortDatePattern: "M/d/yyyy",
  shortestDatePattern: "M/d/yy",
  abbreviatedMonthDayPattern: "d MMM",
  shortMonthDayPattern: "M/d",
  shortTimePattern: "h:mm tt",
  twoDigitYearMax: 2029,

  humanizeFormats: {
    full: {
      dateDaysAgo: "{0} days|ago",
      dateInDays: "in {0}|days",
      dateInWeek: "in a|week",
      dateTimeAndZone: "{0} ({1})",
      dateTimeCombined: "{0}, {1}",
      dateToday: "today",
      dateTomorrow: "tomorrow",
      dateWeekAgo: "a week|ago",
      dateYesterday: "yesterday",
      dimeInSeconds: "in {0}|seconds",
      timeHourAgo: "an hour|ago",
      timeHoursAgo: "{0} hours|ago",
      timeInHour: "in an|hour",
      timeInHours: "in {0}|hours",
      timeInMinute: "in a|minute",
      timeInMinutes: "in {0}|minutes",
      timeInSecond: "in a|second",
      timeInSeconds: "in {0}|seconds",
      timeMinuteAgo: "a minute|ago",
      timeMinutesAgo: "{0} minutes|ago",
      timeSecondAgo: "a second|ago",
      timeSecondsAgo: "{0} seconds|ago"
    },

    short: {
      dateDaysAgo: "{0}d|ago",
      dateInDays: "in|{0}d",
      dateInWeek: "in a|week",
      dateTimeAndZone: "{0} ({1})",
      dateTimeCombined: "{0}, {1}",
      dateToday: "today",
      dateTomorrow: "tomorrow",
      dateWeekAgo: "a week|ago",
      dateYesterday: "yesterday",
      timeHourAgo: "1h|ago",
      timeHoursAgo: "{0}h|ago",
      timeInHour: "in|1h",
      timeInHours: "in|{0}h",
      timeInMinute: "in|1m",
      timeInMinutes: "in|{0}m",
      timeInSecond: "in|1s",
      timeInSeconds: "in|{0}s",
      timeMinuteAgo: "1m|ago",
      timeMinutesAgo: "{0}m|ago",
      timeSecondAgo: "1s|ago",
      timeSecondsAgo: "{0}s|ago"
    }
  },

  rangeFormats: {
    dateTimeFromFormat: "from {0} {1}",
    dateTimeToFormat: "to {0} {1}",
    dateTimeRangeFormat: "from {0} to {1} {2}",
    timeFromFormat: "from {0} {1}",
    timeToFormat: "to {0} {1}",
    timeRangeFormat: "from {0} to {1} {2}"
  }
};

/***/ })
/******/ ]);
});